package org.arefgard.icerya.aop;

import java.util.List;

import org.junit.Test;


public class AspectProxyFactoryTest {
	
	@Test
	public void getProxy() {
		try {
			AspectProxyFactory factory = new AspectProxyFactory(TargetObject.class);
			List<String> patterns = new java.util.ArrayList<String>();
			patterns.add("pri*");
			factory.addInterceptor(patterns, new TraceInterceptor());
			patterns = new java.util.ArrayList<String>();
			patterns.add("print2");
			factory.addInterceptor(patterns, new ExceptionThrowInterceptor());
			Class targetClass = factory.getProxy();
			TargetObject obj = (TargetObject)targetClass.newInstance();
			obj.print1();
			obj.print2();
		}catch(Exception e) {
			e.printStackTrace();
		}
	}
}
